#ifndef __CONFIG_H_
#define __CONFIG_H_

#if !defined(__C251__) && !defined(__C51__)
#include "../debug.h"
#endif

// ٷͷļ
#include "STC32F.h"

// Cִ֧
#include "intrins.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#define PI 3.14159265358979323846
#define _2PI 6.28318530718f
#define _3PI 9.42477796077f
// ܶ
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long

#define LED1 P53
#define LED2 P05
#define LED3 P06
#define LED4 P07
#define LED5 P10

#define KEY1 P44
#define KEY2 P43
#define KEY3 P42
#define KEY4 P41
#define KEY5 P37

#define MU P23
#define MV P22
#define MW P21
#define MSD P20

#define MAIN_Fosc 52000000UL // ʱ
#define Baudrate3 115200UL

#define DIR 1
#define PP 2 // 2Լ

#define voltage_power_supply 12.0 // ߵѹ
extern volatile unsigned long int Tick_Timer;
#define _constrain(amt, low, high) ((amt) < (low) ? (low) : ((amt) > (high) ? (high) : (amt)))

// ͨ˲Ҫȫֱ
typedef struct LowPassConfig
{
    volatile unsigned long int last_time; // ϴʱ
    float last_result;                    // ϴν
} LowPassConfig;

// PIDҪȫֱ
typedef struct PID_Register
{
    volatile unsigned long int timestamp_prev; // ϴʱ
    float P;                                   // Kp
    float I;                                   // Ki
    float D;                                   // Kd
    float output_ramp;                         // ٶ޷
    float limit;                               // ޷
    float error_prev;                          // ϴ
    float output_prev;                         // ϴ
    float integral_prev;                       // ϴλּ
} PID_Register;

// ȫֱ
typedef struct Moto_Config
{
    float Iq;        // q
    float Id;        // d
    float current_a; // A
    float current_b; // B
} Moto_Config;

#endif
