#include "./H_Group/i2c.h"

#define ADDR_R 0x0d
#define ADDR_W 0x0c
bit i2c_busy = 0; // I2Cæ־λ

// I2Cʼ
void I2C_Init(void)
{
	// I2Cܳʼ
	P_SW2 |= 0x10;	 // лΪڶSDA/SCLӿ
	I2CCFG = 0xCB;	 // Ƶð
	I2CMSCR |= 0x80; // ж
	I2CMSST = 0x00;	 // жϱ־λ
}

// ֹͣź
void I2C_Stop(void)
{
	i2c_busy = 1;
	I2CMSCR = 0x86;
	while (i2c_busy)
		;
}

// I2Cдַ
void I2C_Addr(u8 Addr)
{
	I2CTXD = Addr;
	i2c_busy = 1;
	I2CMSCR = 0x89;
	while (i2c_busy)
		;
}

// I2Cд,ںϽACK
void I2C_Send_Data(u8 Dat)
{
	I2CTXD = Dat;
	i2c_busy = 1;
	I2CMSCR = 0x8a;
	while (i2c_busy)
		;
}

// I2Cݣ滹
u8 I2C_Read_Data()
{
	i2c_busy = 1;
	I2CMSCR = 0x8b;
	while (i2c_busy)
		;
	return I2CRXD;
}

// I2Cݣû
u8 I2C_Read_End()
{
	i2c_busy = 1;
	I2CMSCR = 0x8c;
	while (i2c_busy)
		;
	return I2CRXD;
}

void I2C_Isr(void) interrupt 24
{
	if (I2CMSST & 0x40)
	{
		I2CMSST &= ~0x40;
		i2c_busy = 0;
	}
}

// һǶȵ [0,2PI]
float _normalizeAngle(float angle)
{
	float a = fmod(angle, 2 * PI); // ȡڹһгֵ֪
	return a >= 0 ? a : (a + 2 * PI);
	// Ŀʽcondition ? expr1 : expr2
	// Уcondition Ҫֵʽ򷵻 expr1 ֵ򷵻 expr2 ֵԽĿΪ if-else ļʽ
	// fmod ķͬˣ angle ֵΪʱķŽ _2PI ķ෴Ҳ˵ angle ֵС 0  _2PI ֵΪ fmod(angle, _2PI) Ϊ
	// 磬 angle ֵΪ -PI/2_2PI ֵΪ 2PI ʱfmod(angle, _2PI) һ£ͨ _2PI Ƕȹһ [0, 2PI] ķΧڣȷǶȵֵʼΪ
}

float last_angle = 0;
volatile long int full_rotation = 0;
volatile unsigned long int speed_time = 0;

float Read_Angle_Data(void)
{
	u8 a, b;
	u16 result;
	float angle, d_angle;
	I2C_Addr(ADDR_W);
	I2C_Send_Data(0x03);
	I2C_Stop();
	I2C_Addr(ADDR_R);
	a = I2C_Read_End();
	I2C_Stop();
	I2C_Addr(ADDR_W);
	I2C_Send_Data(0x04);
	I2C_Stop();
	I2C_Addr(ADDR_R);
	b = I2C_Read_End();
	I2C_Stop();
	result = a << 8 | b;
	result >>= 2;
	angle = ((float)result / 16384.0 * 360.0) * (PI / 180);
	speed_time = Tick_Timer;
	d_angle = angle - last_angle;
	if (abs(d_angle) > (0.8f * _2PI))
		full_rotation += (d_angle > 0) ? -1 : 1;
	last_angle = angle;
	return angle;
}

float Read_Mechanical_Angle_Data(float angle)
{
	return _normalizeAngle(angle * (float)DIR * (float)PP);
}

volatile unsigned long int speed_last_time = 0;
volatile long int speed_last_full_rotation = 0;
float speed_last_angle = 0;

float Read_Rotation(void)
{
	return (float)full_rotation + last_angle;
}

float Read_Speed_Data(void)
{
	float Ts = 0;
	float speed = 0;
	Ts = (speed_time - speed_last_time) * 1e-6;

	if (Ts <= 0)
		Ts = 1e-3f;
	speed = ((float)(speed_last_full_rotation - full_rotation) * _2PI + (speed_last_angle - last_angle)) / Ts;
	speed = (speed / _2PI * 60); // Ϊrpm
	// 
	speed_last_time = speed_time;
	speed_last_full_rotation = full_rotation;
	speed_last_angle = last_angle;
	return speed; // ٶֵ
}
