#include "./H_Group/adc.h"
#include "./H_Group/config.h"
#include "./H_Group/i2c.h"
#include "./H_Group/pid.h"
#include "./H_Group/pwm.h"
#include "./H_Group/uart.h"

// ̹߳
// ߳
#define Task_Max 20
// ָ߳
u8 Task = 0;
// ߳״̬
u8 Task_This[Task_Max] = {0};
// ߳˽жʱ
u16 Task_Timer[Task_Max] = {0};

// FOCͱ
#define _1_SQRT3 0.57735026919f
#define _2_SQRT3 1.15470053838f
float Ualpha, Ubeta = 0, Ua = 0, Ub = 0, Uc = 0;
#define _3PI_2 4.71238898038f
float zero_electric_angle = 0;

#define _ADC_VOLTAGE 5.0f		// ADC ѹ
#define _ADC_RESOLUTION 4095.0f // ADC ֱ
// ADC ѹת
#define _ADC_CONV ((_ADC_VOLTAGE) / (_ADC_RESOLUTION))
// ͨ˲ȫֱ
LowPassConfig lowpass_i1, lowpass_i2, lowpass_iq, lowpass_id, lowpass_speed;
// PIDȫֱ
PID_Register pid_current, pid_id_zero, pid_speed, pid_pos;
// 
Moto_Config moto;
// ȫּʱ
volatile unsigned long int Tick_Timer = 0;
// ģʽл
u8 Mode = 0;
// ģʽ
#define Current_Mode 1	// ģʽ/ģʽ
#define Speed_Mode 2	// ٶģʽ
#define Postion_Mode 3	// λģʽ
#define OpenLoop_Mode 4 // ģʽ

// 
void Core_Init(void);
void Delay(unsigned int Time);
void Get_Delay(void);
void Pid_Init(void);
void Timer1_Init(void);
void setTorque(float Uq, float Ud, float angle_el);		  // UqUd
float Anti_Pulsation(float input, float angle);			  // ݲת
float LowPassFilter(float x, LowPassConfig *p, float Tf); // ͨ˲ʵֺ
void cal_Iq_Id(Moto_Config *p, float angle_el);			  // iq.id
bit Dir_Flag = 0;
bit Run_Flag = 0;
int iu = 0, iv = 0;						  // ԭʼuԭʼv
float iq = 0, id = 0;					  // 
float set_iq = 0.0;						  // ջλA
float set_speed = 0.0;					  // ջٶȣλrpm
float set_postion = 0.0;				  // ջλãλrad
float set_uq = 0.0, set_ud = 0.0;		  // λV
float this_angle = 0.0;					  // ǰǶ
float this_postion = 0.0, postion = 0.0;  // ǰʵλ,ϵۼλ
float this_speed = 0.0, speed = 0.0;	  // ǰٶ,˲ٶ
float simulation_angle = 0.0;			  // ʱģת
float speed_out = 0.0, postion_out = 0.0; // ݴ
u8 run_freq = 0;
void main(void)
{
	Core_Init();
	Timer1_Init();
	I2C_Init();
	PWM_Init();
	ADC_Init();
	Pid_Init();
	UART3_config(3); // ѡ, 2: ʹTimer2, ֵ: ʹTimer3.
	EA = 1;
	LED1 = LED2 = LED3 = LED4 = LED5 = 0; // رеLED
	MSD = 1;
	while (1)
	{
		Mode = Speed_Mode; // ǿȷģʽ
		LED1 = ~LED1;	   // ϵͳٶָʾ
		if (KEY1 == 0)
			Dir_Flag = 0;
		if (KEY2 == 0)
			Dir_Flag = 1;
		if (KEY4 == 0)
			Run_Flag = 0;
		if (KEY5 == 0)
			Run_Flag = 1;
		LED5 = Run_Flag;
		// ؼϢȡ
		if (Mode == OpenLoop_Mode)
			this_postion = simulation_angle; // ʵʶȡֵ
		else
			this_postion = Read_Angle_Data(); // ȡʵʩǶ
		this_angle = Read_Mechanical_Angle_Data(this_postion);
		this_speed = Read_Speed_Data();
		postion = Read_Rotation();
		moto.current_a = LowPassFilter((((float)ADC_Result_U * _ADC_CONV) - 2.5) / 0.2, &lowpass_i1, 0.02);
		moto.current_b = LowPassFilter((((float)ADC_Result_V * _ADC_CONV) - 2.5) / 0.2, &lowpass_i2, 0.02);
		cal_Iq_Id(&moto, this_angle);
		iq = LowPassFilter(moto.Iq, &lowpass_iq, 0.10);
		id = LowPassFilter(moto.Id, &lowpass_id, 0.10);
		speed = LowPassFilter(this_speed, &lowpass_speed, 0.5);
		// PID㲿
		run_freq++;
		if (run_freq > 16)
			run_freq = 0; // ṩƵ1/4/16
		switch (Mode)
		{
		case OpenLoop_Mode:
		{
			set_uq = 2.0; // ̶ֵ
		}
		break;

		case Current_Mode:
		{
			set_uq = PID_Ctrl(iq - set_iq, &pid_current);
		}
		break;

		case Speed_Mode:
		{
			// PID
			if (run_freq % 16 == 0) // ķ֮һƵִ
				speed_out = PID_Ctrl(set_speed - speed, &pid_speed);
			set_uq = PID_Ctrl(iq - speed_out, &pid_current);
		}
		break;

		case Postion_Mode:
		{
			// PID
			if (run_freq % 16 == 0) // ķ֮һƵִ
				postion_out = PID_Ctrl(postion - set_postion, &pid_pos);
			set_uq = PID_Ctrl(iq - postion_out, &pid_current);
		}
		break;

		default:
			break;
		}
		set_ud = PID_Ctrl(id, &pid_id_zero); // ȡĿֵΪ0
		if (Run_Flag)
			setTorque(set_uq, set_ud, this_angle);
		else
			setTorque(0, 0, this_angle); // صɿؿ
		Task = 1;						 // ߳0
		switch (Task_This[Task])
		{
		case 0:
		{
			if (Run_Flag)
			{
				if (Dir_Flag)
				{
					if (Mode == OpenLoop_Mode)
						simulation_angle += 0.01;
					if (simulation_angle >= _2PI)
						simulation_angle = 0;
					set_iq = 0.4;		 // ٶȿת
					set_speed = 700;	 // ٶȱջת
					set_postion = 12.56; // תȦ
				}
				else
				{
					if (Mode == OpenLoop_Mode)
						simulation_angle -= 0.01;
					if (simulation_angle <= 0)
						simulation_angle = _2PI;
					set_iq = -0.4;		  // ٶȿת
					set_speed = -700;	  // ٶȱջת
					set_postion = -12.56; // תȦ
				}
			}
			else
			{
				set_iq = 0; // ֹͣ
				set_speed = 0;
				set_postion = 0;
			}
			Delay(1);
		}
		break;

		case 2:
		{
			Task_This[Task] = 0;
		}
		break;

		default:
		{
			Get_Delay();
		}
		break;
		}

		Task = 2;
		switch (Task_This[Task])
		{
		case 0:
		{
			if (Run_Flag)
			{
				if (moto.current_a >= 0)
					printf("t0.txt=\"  %1.1fA\"\xff\xff\xff", moto.current_a);
				else
					printf("t0.txt=\"-%1.1fA\"\xff\xff\xff", -moto.current_a);
				if (moto.current_b >= 0)
					printf("t1.txt=\"  %1.1fA\"\xff\xff\xff", moto.current_b);
				else
					printf("t1.txt=\"-%1.1fA\"\xff\xff\xff", -moto.current_b);
				printf("t2.txt=\"%1.1fA\"\xff\xff\xff", iq);
				printf("t3.txt=\"%1.1fA\"\xff\xff\xff", id);
				// ջ
				// printf("add 13,0,%03d\xff\xff\xff", (int)(set_iq * 25) + 50);
				// printf("add 13,1,%03d\xff\xff\xff", (int)(iq * 25) + 50);
				// ٶȱջ
				printf("add 13,0,%03d\xff\xff\xff", (int)(set_speed / 35) + 50);
				printf("add 13,1,%03d\xff\xff\xff", (int)(speed / 35) + 50);
				printf("t4.txt=\"%1.0frpm\"\xff\xff\xff", speed);
			}
			else
			{
				// printf("t4.txt=\"%1.0frpm\"\xff\xff\xff", 0);
			}
			DMA_Send_Start(); // һδDMA
			Delay(10);
		}
		break;

		case 2:
		{
			Task_This[Task] = 0;
		}
		break;

		default:
		{
			Get_Delay();
		}
		break;
		}

		Task = 3;
		switch (Task_This[Task])
		{
		case 0:
		{
			if (RX3_TimeOut > 0) // ʱ
			{
				if (--RX3_TimeOut == 0)
				{
					DMA_UR3R_CR = 0x00; // ֹͣ
					if (RX3_Buffer[1] == 0xff && RX3_Buffer[2] == 0xff && RX3_Buffer[3] == 0xff)
					{
						switch (RX3_Buffer[0])
						{
						case 'k':
							Run_Flag = ~Run_Flag;
							break;
						case 'q':
							Dir_Flag = ~Dir_Flag;
							break;
						}
					}
					DMA_UR3R_CR = 0xa1; // ʼһν
				}
			}
			Delay(1);
		}
		break;

		case 2:
		{
			Task_This[Task] = 0;
		}
		break;

		default:
		{
			Get_Delay();
		}
		break;
		}
	};
}

void Open_ICache(void)
{
	bit fEA;
	if (WTST > 0)
	{
		fEA = EA;
		EA = 0;
		_nop_();
		_nop_();
		TA = 0xaa;
		TA = 0x55;
		ICHECR = 0x01; // дʱر
		_nop_();
		_nop_();
		EA = fEA;
	}
}

void Core_Init(void)
{
	EAXFR = 1;	  // ʹܷⲿXFR
	CKCON = 0x00; // ⲿٶΪ

	AUXR |= 0x80; // ʱʱ1Tģʽ
	TMOD &= 0xF0; // öʱģʽ
	TL0 = 0xB0;	  // öʱʼֵ@52Mhz/100us
	TH0 = 0xEB;	  // öʱʼֵ

	TF0 = 0; // TF0־
	TR0 = 1; // ʱ0ʼʱ
	ET0 = 1; // ʹܶʱ0ж

	// IOʼ
	P0M0 = 0x00;
	P0M1 = 0x1f;
	P1M0 = 0x00;
	P1M1 = 0x3e;
	P2M0 = 0x0f;
	P2M1 = 0xc0;
	P3M0 = 0x00;
	P3M1 = 0x7c;
	P4M0 = 0x00;
	P4M1 = 0xe1;
	P5M0 = 0x00;
	P5M1 = 0xf4;

	// 
	P3PU |= 0x80;
	P4PU |= 0x1e;

	Open_ICache(); // 򿪸ٻ

	// CREԶ׷Ƶ
	// Auto_Fre_Calibrator();
}

void Timer1_Isr(void) interrupt 3
{
	Tick_Timer++;
}

void Timer1_Init(void) // 1΢@52MHz
{
	AUXR |= 0x40; // ʱʱ1Tģʽ
	TMOD &= 0x0F; // öʱģʽ
	TMOD |= 0x20; // öʱģʽ
	TL1 = 0xCC;	  // öʱʼֵ
	TH1 = 0xCC;	  // öʱֵ
	TF1 = 0;	  // TF1־
	TR1 = 1;	  // ʱ1ʼʱ
	ET1 = 1;	  //
	IP |= (1 << 3);
	IPH |= (1 << 3);
}

void Pid_Init(void)
{
	// 
	pid_current.P = 8;
	pid_current.I = 50;
	pid_current.D = 0;
	pid_current.output_ramp = 100000;
	pid_current.limit = voltage_power_supply / 2; // uqȷ
	// ٶȻ趨
	pid_speed.P = 0.002;
	pid_speed.I = 0.01;
	pid_speed.D = 0;
	pid_speed.output_ramp = 100000;
	pid_speed.limit = 1; // 趨
	// λû趨
	pid_pos.P = 2;
	pid_pos.I = 0;
	pid_pos.D = 0;
	pid_pos.output_ramp = 100000;
	pid_pos.limit = 1500; // ٶȷ
	// Id趨
	pid_id_zero.P = 20;
	pid_id_zero.I = 0;
	pid_id_zero.D = 0;
	pid_id_zero.output_ramp = 100000;
	pid_id_zero.limit = voltage_power_supply / 2; // udȷ
}

float Anti_Pulsation(float input, float angle)
{
	float output;
	if (angle >= PI)
		angle -= PI;
	output = sin(angle * 2) * input;
	return output;
}

// ͨ˲
float LowPassFilter(float x, LowPassConfig *p, float Tf)
{
	unsigned long int time_temp = Tick_Timer;
	float dt = (time_temp - p->last_time) * 1e-6f;
	float alpha, y;
	if (dt < 0.0f)
		dt = 1e-3f;
	else if (dt > 0.3f)
	{
		p->last_result = x;
		p->last_time = time_temp;
		return x;
	}
	alpha = Tf / (Tf + dt);
	y = alpha * p->last_result + (1.0f - alpha) * x;
	p->last_result = y;
	p->last_time = time_temp;
	return y;
}

// ͨIa,Ib,IcIq,Id(ĿǰIq)
void cal_Iq_Id(Moto_Config *p, float angle_el)
{
	float I_alpha = p->current_a;
	float I_beta = _1_SQRT3 * p->current_a + _2_SQRT3 * p->current_b;
	float ct = cos(angle_el);
	float st = sin(angle_el);
	p->Id = I_alpha * ct + I_beta * st;
	p->Iq = I_beta * ct - I_alpha * st;
}

void Timer0_Isr(void) interrupt 1
{
	u8 i;
	// ̶߳ʱ
	for (i = 0; i < Task_Max; i++)
	{
		if (Task_Timer[i] > 0)
		{
			Task_Timer[i]--;
		}
	}
}

// ÷Ƕʱ̶1ms
void Delay(unsigned int Time)
{
	Task_Timer[Task] = Time * 10;
	Task_This[Task]++;
}

// ȡǰʱ״̬
void Get_Delay(void)
{
	if (Task_Timer[Task] == 0)
	{
		Task_This[Task]++;
	}
	else
	{
		// ղ
	}
}
#define _Conv 1.15470053838f
// 20239201135Ud
// 2023922SVPWM
void setTorque(float Uq, float Ud, float angle_el)
{
	float Max = 0, Min = 0, Adder = 0;
	// ֵλ
	Uq = _constrain(Uq, -(voltage_power_supply) / 2, (voltage_power_supply) / 2);
	Ud = _constrain(Ud, -(voltage_power_supply) / 2, (voltage_power_supply) / 2);
	angle_el = _normalizeAngle(angle_el);
	// 任
	Ualpha = (Ud * cos(angle_el)) - (Uq * sin(angle_el));
	Ubeta = (Uq * cos(angle_el)) + (Ud * sin(angle_el));

	// 任
	Ua = Ualpha + voltage_power_supply / 2;
	Ub = (sqrt(3) * Ubeta - Ualpha) / 2 + voltage_power_supply / 2;
	Uc = (-Ualpha - sqrt(3) * Ubeta) / 2 + voltage_power_supply / 2;
	// Fast_Svpwmʵ
	Max = Ua > Ub ? (Ua > Uc ? Ua : Uc) : (Ub > Uc ? Ub : Uc);
	Min = Ua < Ub ? (Ua < Uc ? Ua : Uc) : (Ub < Uc ? Ub : Uc);
	Adder = -(Max + Min) / 2;
	Ua = (Ua + Adder) * _Conv, Ub = (Ub + Adder) * _Conv, Uc = (Uc + Adder) * _Conv;
	setPwm(Ua, Ub, Uc);
}
